#INCLUDE "FWMBROWSE.CH"
#INCLUDE "FWMVCDEF.CH"

Static Function ModelDef() 
	// Cria a estrutura a ser usada no Modelo de Dados 
	Local oStruSE1 := FWFormStruct( 1, 'SE1' ) 
	Local oStruSZ1 := FWFormStruct( 1, 'SZ1' )
	//JLJR: Al ser slo modelo, no hay extras para esta personalizacin. 
	// Local oModel := FWLoadModel('FINA070') 
	Local oModel // Modelo de dados que ser construdo

	// Cria o objeto do Modelo de Dados 
	oModel := MPFormModel():New('FormasCobro')
	// Adiciona ao modelo um componente de formulrio 
	oModel:AddFields( 'SE1MASTER', /*cOwner*/, oStruSE1)
	oModel:AddFields( 'SZ1DETALLE', /*cOwner*/, oStruSZ1)

	// Hace la relacin entre los componentes del model //'xFilial(  "SZ1"  )'
	oModel:SetRelation( 'SZ1DETALLE',  ;
		{ {'Z1_FILIAL', 'Z1_RECIBO', 'Z1_PREFIXO', 'Z1_NUM', 'Z1_PARCELA', 'Z1_TIPO'},;
		{'Z1_FILIAL', 'Z1_RECIBO', 'Z1_PREFIXO', 'Z1_NUM', 'Z1_PARCELA', 'Z1_TIPO', 'Z1_FORMAPG', 'Z1_DESFOR',;
		  'Z1_VALOR', 'Z1_MOEDA', 'Z1_HIST', 'Z1_BANCO', 'Z1_AGENCIA', 'Z1_CONTA', 'Z1_MOTBX'} },;
		SZ1->( IndexKey( 1 ) ) )

	// Adiciona a descrio do Modelo de Dados 
	oModel:SetDescription( 'Modelo de dados de Cuentas por Cobrar para Pedido de Venta' ) 

	// Adiciona a descrio do Componente do Modelo de Dados 
	oModel:GetModel( 'SE1MASTER' ):SetDescription('Cuenta por Pagar a Bajar') 
	oModel:GetModel( 'SZ1DETALLE' ):SetDescription('Formas de Cobro') 

	// Retorna el Modelo de datos
Return oModel

Static Function ViewDef() 
	// Crea un objeto de Modelo de datos basado en el ModelDef() del fuente informado 
	Local oModel := FWLoadModel( 'FormasCobro' ) 
	// Crea la estructura a ser utilizada en el View 
	Local oStruSE1 := FWFormStruct( 1, 'SE1' ) 
	Local oStruSZ1 := FWFormStruct( 1, 'SZ1' )
	// Interfaz de visualizacin
	Local oView
	// Crea el objeto del View 
	oView := FWFormView():New()
	// Define cual es el Modelo de datos que ser utilizado en la View 
	oView:SetModel( oModel )
	// Adiciona en nuestra View un control de tipo formulrio
	// (antigua Enchoice)
	oView:AddField( 'VIEW_SE1', oStruSE1, 'SE1MASTER' )
	oView:AddGrid( 'VIEW_SZ1', oStruSZ1, 'SZ1DETALLE' )
	// Crea un "box" horizontal para recibir algn elemento de la view 
	oView:CreateHorizontalBox( 'MASTER' , 15 )
	oView:CreateHorizontalBox( 'DETALLE' , 85 )
	// Relaciona el identificador (ID) de la View como "box"
	oView:SetOwnerView( 'VIEW_SE1', 'MASTER' )
	oView:SetOwnerView( 'VIEW_SZ1', 'DETALLE' )

	// Retorna el objeto de la View creado
Return oView

Static Function MenuDef()
	Local aRotina := {}
	ADD OPTION aRotina Title 'Visualizar' Action 'VIEWDEF.FINA070_MVC'
	OPERATION 2 ACCESS 0
	ADD OPTION aRotina Title 'Incluir' Action 'VIEWDEF.FINA070_MVC'
	OPERATION 3 ACCESS 0
	ADD OPTION aRotina Title 'Alterar' Action 'VIEWDEF.FINA070_MVC'
	OPERATION 4 ACCESS 0
	ADD OPTION aRotina Title 'Excluir' Action 'VIEWDEF.FINA070_MVC'
	OPERATION 5 ACCESS 0
	ADD OPTION aRotina Title 'Imprimir' Action 'VIEWDEF.FINA070_MVC'
	OPERATION 8 ACCESS 0
	ADD OPTION aRotina Title 'Copiar' Action 'VIEWDEF.FINA070_MVC'
	OPERATION 9 ACCESS 0
Return aRotina

User Function FINA070_MVC 
	Local oBrowse 
	// Instanciamento da Classe de Browse
	oBrowse := FWMBrowse():New()
	//  Definio  da  tabela  do  Browse
	oBrowse:SetAlias('SE1')
	// Definio da legenda
	oBrowse:AddLegend( "E1_SALDO > 0", "GREEN", "Con Saldo"  )
	oBrowse:AddLegend( "E1_SALDO = 0", "RED"  , "Dado de Baja"  )
	// Definio de filtro
	oBrowse:SetFilterDefault( "E1_ORIGEM $ 'MATA467N'" )
	// Titulo da Browse 
	// oBrowse:SetDescription('Modelo de dados de Cuentas por Cobrar para Pedido de Venta')
	//  Ativao  da  Classe
	oBrowse:Activate()

Return